﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Core;
using HeuristicLab.Data;
using HeuristicLab.Optimization;

namespace HeuristicLab.Termination {
  [Item("SingleObjectiveQualityTerminator", "")]
  public class SingleObjectiveQualityTerminator : ComparisonTerminator<DoubleValue> {
    public SingleObjectiveQualityTerminator() { }

    public void Parameterize(IParameter qualityParameter, ISingleObjectiveHeuristicOptimizationProblem problem) {
      ComparisonValueParameter.ActualName = qualityParameter.Name;
      if (problem != null) {
        var maximizationParameter = (IValueParameter<BoolValue>)problem.MaximizationParameter;
        if (maximizationParameter != null) {
          bool maximization = maximizationParameter.Value.Value;
          Comparison = maximization ? ComparisonType.Less : ComparisonType.Greater;
          Threshold.Value = maximization ? double.MaxValue : double.MinValue;
        }
      }
    }
  }
}